
mat_out()
{
   int i, j;

   /* need out queue */
   /* Read data from the local device(fd[0]), encode and pass it to 
    * the network (fd[i]) */
   if (FD_ISSET(fd[0], &fdset) && lfd_check_out()) {
      /* read */
      if ((wlen = dev_read(fd[0], buf[0], VTUN_FRAME_SIZE)) < 0) {
         if (errno != EAGAIN && errno != EINTR)
            idle[0] = -1;
         else
            return 1;
      }
      if (!wlen)
         return 1;

      /* select next fd (first live fd) */
      /* full bonding select and skip idle line */
      get_next();
      mat_out2(buf[0], wlen, next);
   }
   return 0;
}

mat_out2(char *ptr, int wlen, int next)
{
   /* write mode */
   {
      /* lzo, shaper, encrypt etc */
      len = wlen;
      lfd_host->stat.byte_out += wlen;
      Out += wlen;
      Out_pps++;
      if ((wlen = lfd_run_out(wlen, ptr, &out)) == -1)
         Idle(99, "lfd_run_out");
      next_seq();

      if (wlen && udp_write2(fd[next], out, wlen, wseq) < 0)
         Idle(next, "next write error");

      gettimeofday(&w_last[next], NULL);        /* to send echo rep */
      lfd_host->stat.comp_out += wlen;
   }
   return 0;
}

mat_in()
{
   int i, j;
   /* Read frames from network(fd[i]), decode and pass them to 
    * the local device (fd[0]) */
   for (i = 1; i < i_max; i++) {
      if (rbuf[i] == 0 && FD_ISSET(fd[i], &fdset) && lfd_check_in()) {
         if ((len = udp_read2(fd[i], buf[i], &rseq)) <= 0)
            continue;
         gettimeofday(&fd_last[i], NULL);
         fl = len & ~VTUN_FSIZE_MASK;
         len = len & VTUN_FSIZE_MASK;
/*
           vtun_syslog(LOG_INFO,"i:%d, fd[i]:%d, %d idle[i]:%d rseq:%d fl:%x, size:%d", i, fd[i], fd_last[i], idle[i], rseq,fl, len);
           if( fl) vtun_syslog(LOG_INFO,"%s i:%d, fd[i]:%d, idle[i]:%d rseq:%d fl:%x, size:%d", 
			   lfd_host->host, i, fd[i], idle[i], rseq, fl, len);
*/

         /* Handle frame flags Do_fl */
         if (fl) {
            int ret;
            ret = Do_fl(fl, i);
            if (ret < 0)
               return ret;
            continue;
         }


         if (i >= i_max)
            continue;
         if (idle[i] == -1) {
            continue;           /* Just ignore when link down status */
         }
         /* finaly setting data */
         gettimeofday(&fd_last[i], NULL);
         rlen[i] = len;
         rbuf[i] = rseq;
         read_count++;
      }
   }

   /* check for all network is timeout */
   if (live_host_num <= 0) {
      /*
         vtun_syslog(LOG_INFO, "Session %s network closed all", lfd_host->host);
       */
      vtun_syslog(LOG_INFO, "%s: all peers closed", lfd_host->host);
      errno = 0;
      return -1;
   }

   /* skip old packet */
   if (read_count >= live_host_num) {   /* read_count is full */
      for (i = 1; i < i_max; i++) {
         int t = rbuf[i];
         if (t == 0)
            continue;
         t = Gap(t, rseq_last);
         if (t < 0) {
            if (t > -100) {
               /* HL CHECK */
               vtun_syslog(LOG_DEBUG, "%s: line %d rewrite gap:%d num:%d", lfd_host->host, i, t, rbuf[i]);
               mat_in2(i);
            } else {
               static cc = 0;
               vtun_syslog(LOG_DEBUG, "%s: line %d skipping gap:%d num:%d", lfd_host->host, i, t, rbuf[i]);
               lfd_host->stat.packet_loss++;
               cc++;
               if (cc > 5) {    /* careful with rseq_last */
                  cc = 0;
                  vtun_syslog(LOG_DEBUG, "%s: changed rseq_last %d to %d", lfd_host->host, rseq_last, rbuf[i]);
                  rseq_last = rbuf[i];
               }
               rbuf[i] = 0;
               read_count--;
            }
         }

      }
   }


   /* skip old packet end */
   /* get min rbuf[i] and set to rseq_last if need */
   /* need more hack */
   if (read_count >= live_host_num) {
      int r_max = rbuf[1], bad_line = 1;
      for (i = 2; i < i_max; i++) {
         int t_rbuf = rbuf[i];
         if (r_max == 0) {
            r_max = t_rbuf;
            continue;
         }
         if (t_rbuf == 0)
            continue;
         if (-MAX_SEQ / 2 < t_rbuf - r_max && t_rbuf - r_max < MAX_SEQ / 2) {
            if (r_max > t_rbuf) {
               r_max = t_rbuf;
               bad_line = i;
            }
         } else if (r_max < t_rbuf) {
            r_max = t_rbuf;
            bad_line = i;
         }
      }

      /* get bad line */
      /*
         for (i = 1; i < read_count; i++) {
         bad_line++;
         if (bad_line >= i_max)
         bad_line -= i_max - 1;
         while (rbuf[bad_line] == 0) {
         bad_line++;
         if (bad_line >= i_max)
         bad_line -= i_max - 1;
         }
         }
       */

      if (rseq_last != r_max) {
         lfd_host->stat.packet_loss++;
         /*
            if( i_max < 4) vtun_syslog(LOG_DEBUG,"Packet loss seq:%d port:%d ", rseq_last, bad_line);
            if( i_max == 4)
            vtun_syslog(LOG_DEBUG,"%s loss %d, (%d:%d:%d)%d (%d) gap:%d (%d:%d:%d)", lfd_host->host, rseq_last, rbuf[1], rbuf[2], rbuf[3], bad_line, r_max, Gap(r_max,rseq_last), rlen[1], rlen[2], rlen[3]);
            if( i_max == 5)
            vtun_syslog(LOG_DEBUG,"%s loss %d, (%d:%d:%d:%d)%d (%d) gap:%d (%d:%d:%d:%d)", lfd_host->host, rseq_last, rbuf[1], rbuf[2], rbuf[3], rbuf[4], bad_line, r_max, Gap(r_max,rseq_last), rlen[1], rlen[2], rlen[3], rlen[4]);
          */
      }
      rseq_last = r_max;
   }




   /* skip jitter packets */
   /* when read_count is full */
   if (read_count >= live_host_num) {
      for (i = 1; i < i_max; i++) {
         int t = rbuf[i];
         if (t == 0)
            continue;
         t = Gap(t, rseq_last);
         if (t > i_max * 5) {

            if (i_max == 4)
               vtun_syslog(LOG_DEBUG,
                           "%s jam %d, (%d:%d:%d)%d gap:%d (%d:%d:%d)",
                           lfd_host->host, rseq_last, rbuf[1], rbuf[2], rbuf[3], i, t, rlen[1], rlen[2], rlen[3]);
            if (i_max == 5)
               vtun_syslog(LOG_DEBUG,
                           "%s jam %d, (%d:%d:%d:%d)%d gap:%d (%d:%d:%d:%d)",
                           lfd_host->host, rseq_last, rbuf[1], rbuf[2], rbuf[3], rbuf[4], i, t, rlen[1], rlen[2], rlen[3], rlen[4]);

            lfd_host->stat.packet_loss++;
            rseq_last = rbuf[i];
            if (++jitter[i] > 10) {
               vtun_syslog(LOG_DEBUG, "%s traffic problem occured line:%d,num:%d restarting", lfd_host->host, i, jitter[i]);
               live_host_num = 0;
            }
         }
      }
   }
   /* End skip jitter packets */
/*
*/
   /* write by packet order when all ready */
   /* get order */
   if (read_count > 0) {
      for (j = 1; j < i_max; j++) {
         for (i = 1; i < i_max; i++) {
            if (rbuf[i] == rseq_last) {
               int ret;
               ret = mat_in2(i);
               if (ret != 0)
                  return ret;
               rseq_last++;
               if (rseq_last > MAX_SEQ)
                  rseq_last = 1;
            }
            if (read_count < 1)
               break;
         }
         if (read_count < 1)
            break;
      }
   }
   return 0;
}

mat_in2(int i)
{

   len = rlen[i];
   lfd_host->stat.comp_in += len;

   if ((len = lfd_run_in(len, buf[i], &out)) == -1)
      Idle(i, "lfd_run_in");
   if (len && dev_write(fd[0], out, len) < 0) {
      if (errno != EAGAIN && errno != EINTR)
         Idle(i, "local write error");
      else
         return -2;
   }

   lfd_host->stat.byte_in += len;
   lfd_host->stat.packet_count++;
   In += len;
   In_pps++;
   rbuf[i] = 0;
   read_count--;
   return 0;
}
